/**
 * Copyright (C) 2005-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the Honest Public License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * Honest Public License for more details.
 *
 * You should have received a copy of the Honest Public License
 * along with this program; if not, write to Funambol,
 * 643 Bair Island Road, Suite 305 - Redwood City, CA 94063, USA
 */
package com.funambol.email.util;


/**
 * @version $Id: Def.java,v 1.15 2006/08/08 09:33:00 gibi Exp $
 */
public class Def {


    public static final String LOGGER_NAME = "funambol.email";

    public static final String PRODUCT_NAME = "Funambol Email Connector";

    public static final String SEPARATOR = "/";

    public static final String TYPE_EMAIL  = "application/vnd.omads-email+xml";
    public static final String TYPE_FOLDER = "application/vnd.omads-folder+xml";

    public static final String ID_COUNTER_SENT   = "email.sentid";
    public static final String ID_COUNTER_FOLDER = "email.folderid";

    // protocols
    public static final String PROTOCOL_IMAP = "imap";
    public static final String PROTOCOL_POP3 = "pop3";

    //protocols default ports
    public static final int PROTOCOL_IMAP_PORT = 143;
    public static final int PROTOCOL_POP3_PORT = 110;

    //folder IDs
    public static final String FOLDER_ROOT_ID   = "ROOT";
    public static final String FOLDER_INBOX_ID  = "I";
    public static final String FOLDER_OUTBOX_ID = "O";
    public static final String FOLDER_SENT_ID   = "S";
    public static final String FOLDER_DRAFTS_ID = "D";
    public static final String FOLDER_TRASH_ID  = "T";

    //folder GUIDs
    public static final String FOLDER_ROOT_GUID = "ROOT";
    public static final String FOLDER_INBOX_GUID = FOLDER_ROOT_ID +
            SEPARATOR +
            FOLDER_INBOX_ID;
    public static final String FOLDER_OUTBOX_GUID = FOLDER_ROOT_ID +
            SEPARATOR +
            FOLDER_OUTBOX_ID;
    public static final String FOLDER_SENT_GUID = FOLDER_ROOT_ID +
            SEPARATOR +
            FOLDER_SENT_ID;
    public static final String FOLDER_DRAFTS_GUID = FOLDER_ROOT_ID +
            SEPARATOR +
            FOLDER_DRAFTS_ID;
    public static final String FOLDER_TRASH_GUID = FOLDER_ROOT_ID +
            SEPARATOR +
            FOLDER_TRASH_ID;

    //default folder names
    public static final String FOLDER_ROOT_ENG   = "";
    public static final String FOLDER_INBOX_ENG  = "Inbox";
    public static final String FOLDER_OUTBOX_ENG = "Outbox";
    public static final String FOLDER_SENT_ENG   = "Sent Items";
    public static final String FOLDER_DRAFTS_ENG = "Drafts";
    public static final String FOLDER_TRASH_ENG  = "Deleted Items";


    //folder roles
    public static final String FOLDER_INBOX_ROLE  = "inbox";
    public static final String FOLDER_OUTBOX_ROLE = "outbox";
    public static final String FOLDER_SENT_ROLE   = "sent";
    public static final String FOLDER_DRAFTS_ROLE = "drafts";
    public static final String FOLDER_TRASH_ROLE  = "deleted";

    //NOKIA folder names
    public static final String NOKIA_INBOX_ENG  = "Remote Inbox";
    public static final String NOKIA_OUTBOX_ENG = "Remote Outbox";
    public static final String NOKIA_SENT_ENG   = "Remote Sent";
    public static final String NOKIA_DRAFTS_ENG = "Remote Drafts";


    // filter
    // time filter field
    public static final String FILTER_TIME_FIELD = "modified";
    // id filter field
    public static final String FILTER_ID_FIELD   = "LUID";
    // size filter field
    public static final String FILTER_SIZE_LABEL_HEADER = "emailitem";
    public static final String FILTER_SIZE_LABEL_BODY   = "texttype";
    public static final String FILTER_SIZE_LABEL_ATTACH = "attachtype";
    // size filter values
    //  0 0 0 0 0 1 = 1   FILTER_SIZE_H         (get only header)
    //  0 0 0 1 0 1 = 5   FILTER_SIZE_H_B       (get header and body)
    //  0 0 1 1 1 1 = 15  FILTER_SIZE_H_BPERC
    //  0 1 0 1 0 1 = 21  FILTER_SIZE_H_B_A     (get all message)
    //  1 1 1 1 1 1 = 63  FILTER_SIZE_H_B_APERC
    public static final int FILTER_SIZE_H          = 1;
    public static final int FILTER_SIZE_H_B        = 5;
    public static final int FILTER_SIZE_H_B_PERC   = 15;
    public static final int FILTER_SIZE_H_B_A      = 21;
    public static final int FILTER_SIZE_H_B_A_PERC = 63;
    // folder filter values
    //  0 0 0 0 1 -->  1  inbox
    //  0 0 0 1 1 -->  3  inbox + outbox
    //  0 0 1 1 1 -->  7  inbox + outbox + sent
    //  0 1 1 1 1 -->  15 inbox + outbox + sent + draft
    //  1 1 1 1 1 -->  31 inbox + outbox + sent + draft + trash
    public static final int FILTER_FOLDER_I = 1;
    public static final int FILTER_FOLDER_IO = 3;
    public static final int FILTER_FOLDER_IOS = 7;
    public static final int FILTER_FOLDER_IOSD = 15;
    public static final int FILTER_FOLDER_IOSDT = 31;

    // Header label
    public static final String HEADER_LABEL_MESSAGE_ID  = "Message-ID";
    public static final String HEADER_LABEL_DATE        = "Date";
    public static final String HEADER_LABEL_SYNCMESSAGE = "X-Funambol";

    public static final String HEADER_VALUE_SYNCMESSAGE = "true";

    // default Content for a mail
    public static final String DEFAULT_CONTENT_VALUE_BODY        = "";
    public static final String DEFAULT_CONTENT_VALUE_CONTENTTYPE = "text/plain; charset=us-ascii";

    //message encoding types
    public static final String ENCODE_QUOTED_PRINTABLE = "quoted-printable";
    public static final String ENCODE_BASE64           = "base64";

}
